
#ifndef LUBISHEV_DB_H
#define LUBISHEV_DB_H

#include <lubishev/Types.h>

#include <QString>

namespace lubishev {

class DB {
    public:
        virtual ~DB() { }

        //! \return ID.
        virtual QString createEvent(time_t start, time_t end) = 0;
        //! \return Tags.
        virtual QStringList eventTags(const QString &id) = 0;
        //! \return IDs.
        virtual QStringList eventsWithin(time_t start, time_t end) = 0;
        virtual void eventTimes(const QString &id, time_t *start, time_t *end) = 0;
        virtual void setDir(const QString &dir) = 0;
        virtual void setEventTags(const QString &id, const QStringList &list) = 0;
        virtual void setEventTimes(const QString &id, time_t start, time_t end) = 0;
};

} // namespace lubishev

#endif // LUBISHEV_DB_H

