
#include <lubishev/Edit.h>

#include <iostream>
#include <QApplication>
#include <QStringList>

namespace lubishev {

Edit::Edit(QWidget *parent) : QPlainTextEdit(parent), mSE(0) {
    setVisible(false);
    // Set text colour forever.
    QPalette pal = QApplication::palette();
    QColor text = QColor(255, 255, 255);
    QColor background = QColor(0, 0, 0, 220);
    pal.setColor(QPalette::Base, background);
    pal.setColor(QPalette::Text, text);
    QApplication::setPalette(pal);
}

void Edit::display(SceneEvent *e) {
    mSE = e;
    // Fill in the event tags.
    QStringList list = e->event()->tags();
    QString s;
    for (s32 i = 0; i < list.size(); i++)
        if (s.length())
            s += "\n" + list[i];
        else
            s += list[i];
    document()->setPlainText(s);
    setVisible(true);
    setFocus();
}

void Edit::hide() {
    setVisible(false);
    mSE = 0;
}

void Edit::keyPressEvent(QKeyEvent *e) {
    if (e->key() == Qt::Key_Escape) {
        QString s = toPlainText();
        QStringList tags = s.split("\n", QString::SkipEmptyParts);
        mSE->event()->setTags(tags);
        mSE->refreshText();
        hide();
        parentWidget()->setFocus();
    }
    else
        QPlainTextEdit::keyPressEvent(e);
}

} // namespace lubishev

